agents

## Class Environment

- java.lang.Object
- - agents.Environment

-     public class Environment
      extends java.lang.Object

  Version:
    1.0
  Author:
    Alan Mills

    This class implements the simulation's Environment. The Environment is the container for the model’s agents. It creates the simulation’s agents, and maintains a list of Person agents, a list Physician agents, and a list of Insurance Company agents (there is only one). It also schedules agent behaviors, and manages the passing of messages among agents.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Environment(repast.simphony.space.continuous.ContinuousSpace<java.lang.Object> pSpace, repast.simphony.context.Context<java.lang.Object> pContext)` Constructs an Environment agent.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `getAgentLabels()`
    `static double` | `getDisease1Probability()`
    `static double` | `getDisease2Probability()`
    `static java.util.ArrayList<HealthInsuranceCompany>` | `getHealthInsuranceCompanyList()`
    `static java.lang.String` | `getInitialPCPAssignment()`
    `static double` | `getInsuranceCompanyFirstGoalPercent_Income()`
    `static double` | `getInsuranceCompanyFirstGoalPercent_NetworkSize()`
    `static double` | `getInsuranceCompanyFirstGoalPercent_NetworkStability()`
    `static int` | `getMaximumSimulationPeriods()`
    `static java.util.ArrayList<Message>` | `getMessageList()`
    `static int` | `getNumberOfPCPs()`
    `static int` | `getNumberOfPersons()`
    `static int` | `getNumberOfSpecialists()`
    `static java.lang.String` | `getOutputFileName()`
    `static java.lang.String` | `getOverrideParameters()`
    `static double` | `getPcpErrorRate()`
    `static double` | `getPcpFirstGoalPercent_Care()`
    `static double` | `getPcpFirstGoalPercent_Conformance()`
    `static double` | `getPcpFirstGoalPercent_Income()`
    `static int` | `getPcpMaximumPatientLoad()`
    `static int` | `getPcpMinimumPatientLoad()`
    `static int` | `getPcpQualityThreshold()`
    `static java.lang.String` | `getPersonDistributionType()`
    `static double` | `getPersonFirstGoalPercent_Conformance()`
    `static double` | `getPersonFirstGoalPercent_Convenience()`
    `static double` | `getPersonFirstGoalPercent_Treatment()`
    `static java.util.ArrayList<Person>` | `getPersonList()`
    `static double` | `getPersonNeighborhoodRadius()`
    `static double` | `getPersonStandardDeviation()`
    `static double` | `getPhysicianConvenienceRadius()`
    `static java.lang.String` | `getPhysicianDistributionType()`
    `static java.util.ArrayList<Physician>` | `getPhysicianList()`
    `static double` | `getPhysicianNeighborhoodRadius()`
    `static double` | `getPhysicianStandardDeviation()`
    `static double` | `getRandomNumberSeed()`
    `static java.lang.String` | `getReferralSpecialistSelectionCriterion()`
    `static int` | `getRunNumber()` Gets the run number.
    `static double` | `getSpecialistErrorRate()`
    `static double` | `getSpecialistFirstGoalPercent_Care()`
    `static double` | `getSpecialistFirstGoalPercent_Conformance()`
    `static double` | `getSpecialistFirstGoalPercent_Income()`
    `static int` | `getSpecialistMaximumPatientLoad()`
    `static int` | `getSpecialistMinimumPatientLoad()`
    `static int` | `getSpecialistQualityThreshold()`
    `static double` | `getTreatmentCostForPCPReferral()`
    `static double` | `getTreatmentCostForPCPTreatment1()`
    `static double` | `getTreatmentCostForPCPTreatment2()`
    `static double` | `getTreatmentCostForPCPTreatmentZ()`
    `static double` | `getTreatmentCostForSpecialistTreatment1()`
    `static double` | `getTreatmentCostForSpecialistTreatment2()`
    `static double` | `getTreatmentCostForSpecialistTreatmentZ()`
    `static double` | `getTreatmentPainThreshold()`
    `static java.lang.String` | `getWriteOutputFile()`
    `static void` | `m1_SendMessage(Message pMessage)` Adds a message to the message list.
    `static java.util.ArrayList<Message>` | `m2_GetMessages(AgentID pIDAgent, Constants.MessageType pMessageType)` Gets an agent's new messages of a particular type.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Environment

          public Environment(repast.simphony.space.continuous.ContinuousSpace<java.lang.Object> pSpace,
                     repast.simphony.context.Context<java.lang.Object> pContext)
                      throws java.io.IOException

      Constructs an Environment agent. The constructor sets the Environment's attributes based on input parameters, creates the simulation's agents, creates lists of the agents, and schedules agent behaviors.
      Parameters:
        `pSpace` - The identifier for the "space" simulation environment
        `pContext` - The identifier for the simulation "context"
      Throws:
        `java.io.IOException`

  - ### Method Detail

    - #### m1_SendMessage

          public static void m1_SendMessage(Message pMessage)

      Adds a message to the message list.
      Parameters:
        `pMessage` - a message an agent sends to another agent

    - #### m2_GetMessages

          public static java.util.ArrayList<Message> m2_GetMessages(AgentID pIDAgent,
                                                    Constants.MessageType pMessageType)

      Gets an agent's new messages of a particular type. This method returns all the messages of the requested type in the message list for the agent calling the method. After a message is returned, it is removed from the message list.
      Parameters:
        `pIDAgent` - An agent's identifier
      Returns:
        agentMessageList The requested messages

    - #### getRunNumber

          public static int getRunNumber()

      Gets the run number.

    - #### getAgentLabels

          public static java.lang.String getAgentLabels()

    - #### getMaximumSimulationPeriods

          public static int getMaximumSimulationPeriods()

    - #### getRandomNumberSeed

          public static double getRandomNumberSeed()

    - #### getNumberOfPersons

          public static int getNumberOfPersons()

    - #### getNumberOfPCPs

          public static int getNumberOfPCPs()

    - #### getNumberOfSpecialists

          public static int getNumberOfSpecialists()

    - #### getPersonDistributionType

          public static java.lang.String getPersonDistributionType()

    - #### getPersonStandardDeviation

          public static double getPersonStandardDeviation()

    - #### getPhysicianDistributionType

          public static java.lang.String getPhysicianDistributionType()

    - #### getPhysicianStandardDeviation

          public static double getPhysicianStandardDeviation()

    - #### getDisease1Probability

          public static double getDisease1Probability()

    - #### getDisease2Probability

          public static double getDisease2Probability()

    - #### getInitialPCPAssignment

          public static java.lang.String getInitialPCPAssignment()

    - #### getPersonFirstGoalPercent_Treatment

          public static double getPersonFirstGoalPercent_Treatment()

    - #### getPersonFirstGoalPercent_Convenience

          public static double getPersonFirstGoalPercent_Convenience()

    - #### getPersonFirstGoalPercent_Conformance

          public static double getPersonFirstGoalPercent_Conformance()

    - #### getPcpFirstGoalPercent_Care

          public static double getPcpFirstGoalPercent_Care()

    - #### getPcpFirstGoalPercent_Income

          public static double getPcpFirstGoalPercent_Income()

    - #### getPcpFirstGoalPercent_Conformance

          public static double getPcpFirstGoalPercent_Conformance()

    - #### getSpecialistFirstGoalPercent_Care

          public static double getSpecialistFirstGoalPercent_Care()

    - #### getSpecialistFirstGoalPercent_Income

          public static double getSpecialistFirstGoalPercent_Income()

    - #### getSpecialistFirstGoalPercent_Conformance

          public static double getSpecialistFirstGoalPercent_Conformance()

    - #### getInsuranceCompanyFirstGoalPercent_Income

          public static double getInsuranceCompanyFirstGoalPercent_Income()

    - #### getInsuranceCompanyFirstGoalPercent_NetworkStability

          public static double getInsuranceCompanyFirstGoalPercent_NetworkStability()

    - #### getInsuranceCompanyFirstGoalPercent_NetworkSize

          public static double getInsuranceCompanyFirstGoalPercent_NetworkSize()

    - #### getPersonNeighborhoodRadius

          public static double getPersonNeighborhoodRadius()

    - #### getPhysicianNeighborhoodRadius

          public static double getPhysicianNeighborhoodRadius()

    - #### getPhysicianConvenienceRadius

          public static double getPhysicianConvenienceRadius()

    - #### getTreatmentCostForPCPTreatment1

          public static double getTreatmentCostForPCPTreatment1()

    - #### getTreatmentCostForPCPTreatment2

          public static double getTreatmentCostForPCPTreatment2()

    - #### getTreatmentCostForPCPTreatmentZ

          public static double getTreatmentCostForPCPTreatmentZ()

    - #### getTreatmentCostForPCPReferral

          public static double getTreatmentCostForPCPReferral()

    - #### getTreatmentCostForSpecialistTreatment1

          public static double getTreatmentCostForSpecialistTreatment1()

    - #### getTreatmentCostForSpecialistTreatment2

          public static double getTreatmentCostForSpecialistTreatment2()

    - #### getTreatmentCostForSpecialistTreatmentZ

          public static double getTreatmentCostForSpecialistTreatmentZ()

    - #### getPcpQualityThreshold

          public static int getPcpQualityThreshold()

    - #### getSpecialistQualityThreshold

          public static int getSpecialistQualityThreshold()

    - #### getTreatmentPainThreshold

          public static double getTreatmentPainThreshold()

    - #### getPcpErrorRate

          public static double getPcpErrorRate()

    - #### getSpecialistErrorRate

          public static double getSpecialistErrorRate()

    - #### getPcpMinimumPatientLoad

          public static int getPcpMinimumPatientLoad()

    - #### getSpecialistMinimumPatientLoad

          public static int getSpecialistMinimumPatientLoad()

    - #### getPcpMaximumPatientLoad

          public static int getPcpMaximumPatientLoad()

    - #### getSpecialistMaximumPatientLoad

          public static int getSpecialistMaximumPatientLoad()

    - #### getReferralSpecialistSelectionCriterion

          public static java.lang.String getReferralSpecialistSelectionCriterion()

    - #### getOverrideParameters

          public static java.lang.String getOverrideParameters()

    - #### getWriteOutputFile

          public static java.lang.String getWriteOutputFile()

    - #### getOutputFileName

          public static java.lang.String getOutputFileName()

    - #### getPersonList

          public static java.util.ArrayList<Person> getPersonList()

    - #### getPhysicianList

          public static java.util.ArrayList<Physician> getPhysicianList()

    - #### getHealthInsuranceCompanyList

          public static java.util.ArrayList<HealthInsuranceCompany> getHealthInsuranceCompanyList()

    - #### getMessageList

          public static java.util.ArrayList<Message> getMessageList()